<?php
/**
 * @package	SwipeHQ Checkout payment plugin for HikaShop
 * @version	1.5.1
 * @author	OptimizerHQ Ltd.
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikashoppaymentSWIPEHQ extends JPlugin
{

 
	var $error_msg = array();

	function onPaymentDisplay(&$order,&$methods,&$usable_methods) {

		if(!empty($methods)){
			foreach($methods as $method){
				if($method->payment_type!='swipehq' || !$method->enabled){
					continue;
				}
				if(!empty($method->payment_zone_namekey)){
					$zoneClass=hikashop::get('class.zone');
					$zones = $zoneClass->getOrderZones($order);
					if(!in_array($method->payment_zone_namekey,$zones)){
						return true;
					}
				}
				$usable_methods[$method->ordering] = $method;
			}
		}
                
		return true;
	}

	function onPaymentSave(&$cart,&$rates,&$payment_id) {
		$usable = array();
		$this->onPaymentDisplay($cart,$rates,$usable);
		$payment_id = (int) $payment_id;
		foreach($usable as $usable_method){
			if($usable_method->payment_id==$payment_id){
				return $usable_method;
			}
		}
		return false;
	}

	function onAfterOrderConfirm(&$order,&$methods,$method_id) {
		$method =& $methods[$method_id];

		$currencyClass = hikashop::get('class.currency');
		$currencies = null;
		$currencies = $currencyClass->getCurrencies($order->order_currency_id,$currencies);
		$currency = $currencies[$order->order_currency_id];

		hikashop::loadUser(true,true); //reset user data in case the emails were changed in the email code
		$user = hikashop::loadUser(true);
		$lang = &JFactory::getLanguage();
		$locale = strtolower(substr($lang->get('tag'),0,2));
		$httpsHikashop = str_replace('http://','https://', HIKASHOP_LIVE);
		$notify_url = $httpsHikashop.'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=swipehq&tmpl=component&lang='.$locale;
		$return_url = $httpsHikashop.'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=swipehq&tmpl=component&user_return=1&lang='.$locale;

		$app =& JFactory::getApplication();
		$address = $app->getUserState( HIKASHOP_COMPONENT.'.billing_address');

		$price = round($order->cart->full_total->prices[0]->price_value_with_tax,(int)$currency->currency_locale['int_frac_digits']);

                /*** SwipeHQ ***/
		
				// check currency
				$acceptedCurrencies = $this->getAcceptedCurrencies($method->payment_params->merchant_id, $method->payment_params->api_key, $method->payment_params->api_url);
				if(in_array($currency->currency_code, $acceptedCurrencies)){

	                //get order ID
	                $order_id = $order->order_id;
	
	                //get list of ordered pruducts
	                $products = '';
	                $items = $order->cart->products;
	                foreach ($items as $item) {
	                    $products .= $item->order_product_quantity . ' x ' . $item->order_product_name . ($item != end($items) ? '<br />' : '');
	                }
	
	                //get identifier ID using TransactionIdentifier API
	                $params = array (
	                    'merchant_id'           => $method->payment_params->merchant_id,
	                    'api_key'               => $method->payment_params->api_key,
	                    'td_item'               => 'Order ID ' . $order_id,
	                    'td_description'        => $products,
	                    'td_amount'             => $price,
	                    'td_currency'           => $currency->currency_code,
	                    'td_default_quantity'   => 1,
	                    'td_user_data'          => $order_id
	                );
                        
                        if(!empty($order->customer)){
                            if(!empty($order->customer->user_email)){
                                $params['td_email'] = $order->customer->user_email;
                            }
                        }
	
	                if ($method->payment_params->debug) { echo 'Params sent to SwipeHQ: ' .  json_encode($params) . '<br /><br />'; }
	
	                $response = $this->_sendRequest($method->payment_params->api_url.'createTransactionIdentifier.php', $params);
	
	                if ($method->payment_params->debug) { echo 'SwipeHQ call return: ' .  $response . '<br /><br />'; }
	
	                $response_data = json_decode($response);
	                if ($response_data->response_code == 200 && !empty($response_data->data->identifier)) {
	                    $url = $method->payment_params->payment_page_url;
	                    $vars = array (
	                        'checkout' => 'true',
	                        'identifier_id' => $response_data->data->identifier
	                    );
	                } else {
	                    $url = '';
	                    $vars = '';
	                    $app =& JFactory::getApplication();
	                    $app->enqueueMessage('SwipeHQ Checkout error. Please try again.');
	                }
				}else{
					$url = '';
					$vars = '';
					$app =& JFactory::getApplication();
					$app->enqueueMessage('Sorry, you cannot pay in currency: '.$currency->currency_code.' with Swipe. If paying with Swipe you must use one of these currencies: '.join(', ', $acceptedCurrencies).'.');
					return true;
				}
                /*** END SwipeHQ ***/

		if(!HIKASHOP_J30)
			JHTML::_('behavior.mootools');
		else
			JHTML::_('behavior.framework');
		$app =& JFactory::getApplication();
		$name = $method->payment_type.'_end.php';
		$path = JPATH_THEMES.DS.$app->getTemplate().DS.'hikashoppayment'.DS.$name;
		if(!file_exists($path)){
			if(version_compare(JVERSION,'1.6','<')){
				$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$name;
			}else{
				$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$method->payment_type.DS.$name;
			}
			if(!file_exists($path)){
				return true;
			}
		}
		require($path);
		return true;
	}

	function onPaymentNotification(&$statuses) {
            $request = $_REQUEST;

            $isLPN = isset($request['td_user_data']);
            $isCallback = isset($request['result']) && isset($request['user_data']);
            
            if($isLPN){
                $order_id = $request['td_user_data'];
                
                $pluginsClass = hikashop::get('class.plugins');
                $elements = $pluginsClass->getMethods('payment','swipehq');
                if(empty($elements)) return false;
                $element = reset($elements);

                $orderClass = hikashop::get('class.order');
                $order = $orderClass->get($order_id);

                // TODO: do we need to check to make sure the order has not already been marked as paid for?
                $order->old_status->order_status = $order->order_status;

                $app =& JFactory::getApplication();

                $url = HIKASHOP_LIVE.'administrator/index.php?option=com_hikashop&ctrl=order&task=edit&order_id='.$order->order_id;
                $order_text = "\r\n".JText::sprintf('NOTIFICATION_OF_ORDER_ON_WEBSITE',$order->order_number,HIKASHOP_LIVE);
                $order_text .= "\r\n".str_replace('<br/>',"\r\n",JText::sprintf('ACCESS_ORDER_WITH_LINK',$url));

                $order->history->history_reason=JText::sprintf('AUTOMATIC_PAYMENT_NOTIFICATION');
                $order->history->history_notified = 0;
                $order->history->history_amount = $order->order_full_price;
                $order->history->history_payment_id = $element->payment_id;
                $order->history->history_payment_method = $element->payment_type;
                $order->history->history_data = '';
                $order->history->history_type = 'payment';
                
                $mailer = JFactory::getMailer();
                $config =& hikashop::config();
                $sender = array(
                                $config->get('from_email'),
                                $config->get('from_name') );
                $mailer->setSender($sender);
                $mailer->addRecipient(explode(',',$config->get('payment_notification_email')));

                $is_verified = $this->_verifyTransaction($request['transaction_id'], $element->payment_params->merchant_id, $element->payment_params->api_key, $element->payment_params->api_url);
                if ($request['transaction_approved'] == 'yes' && $is_verified && ($request['status'] == 'accepted' || $request['status'] == 'test-accepted')) {
                    // Payment was successful, so update the order's state, send order email
                    
                    $order->order_status = $element->payment_params->verified_status;
                    $order->history->history_notified = 1;
                    $payment_status = 'confirmed';

                } else {
                    // There is a problem in the response we got
                    $order->order_status = $element->payment_params->invalid_status;
                    $payment_status = 'cancelled';
                    $order_text = 'SwipeHQ Checkout State: ' . $vars['state'] ."\r\n". $order_text;
                }
                
                $order->mail_status = $statuses[$order->order_status];
			 	$mailer->setSubject(JText::sprintf('PAYMENT_NOTIFICATION_FOR_ORDER','SWIPEHQ',$payment_status,$order->order_number));
				$body = str_replace('<br/>',"\r\n",JText::sprintf('PAYMENT_NOTIFICATION_STATUS','SWIPEHQ',$payment_status)).' '.JText::sprintf('ORDER_STATUS_CHANGED',$order->mail_status)."\r\n\r\n".$order_text;
				$mailer->setBody($body);
				$mailer->Send();
		                
				$orderClass->save($order);
                
				echo 'LPN success. Order updated and Email sent';
                exit;
                
            //Result page (moving user to the success page)
            }elseif($isCallback){
                $url = JURI::root() . 'index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id=' . (int) $request['user_data'];
                $app =& JFactory::getApplication();
                
                if ($request['result'] == 'declined' || $request['result'] == 'test-declined') {
                    JError::raiseWarning( 100, 'Your payment has been declined' );
                }
                
                if ($request['result'] == 'test-accepted' || $request['result'] == 'test-declined') {
                    JError::raiseNotice( 100, 'This was a Test Transaction with SwipeHQ' );
                }
                
                $app->redirect($url);
            }else{
            	die('Error, unknown Swipe callback');
            }
	}

	function onPaymentConfiguration(&$element) {
		
		$this->swipehq = JRequest::getCmd('name','swipehq');
		if(empty($element)){
			$element = new stdClass();
			$element->payment_name='SwipeHQ Checkout';
			$element->payment_description='You can pay by credit card using this payment method';
			$element->payment_images='MasterCard,VISA';
			$element->payment_type=$this->swipehq;
			$element->payment_params= new stdClass();
			$element->payment_params->login='';
			$element->payment_params->password='';
	
			
	
			if( property_exists( get_class($element->payment_params), 'merchant_id' ) & property_exists( get_class($element->payment_params), 'api_key' )&property_exists( get_class($element->payment_params), 'api_url' )){
				
      $element->payment_params->currency = $this->getDefaultCurrency($element->payment_params->merchant_id, $element->payment_params->api_key, $element->payment_params->api_url);
	  
 }
					
			
			$element->payment_params->ask_ccv = false;
			$element->payment_params->security = false;
			$element->payment_params->pending_status='created';
			$element->payment_params->verified_status='confirmed';
			$element = array($element);
		}

		$this->toolbar = array(
			'save',
			'apply',
			'cancel',
			'|',
			array('name' => 'pophelp', 'target' =>'payment-swipehq-form')
		);
		hikashop::setTitle('SWIPEHQ','plugin','plugins&plugin_type=payment&task=edit&name='.$this->swipehq);
		$app = JFactory::getApplication();
		$app->setUserState( HIKASHOP_COMPONENT.'.payment_plugin_type', $this->swipehq);
		$this->address = hikashop::get('type.address');
		$this->category = hikashop::get('type.categorysub');
		$this->category->type = 'status';
		
		
	}

	function onPaymentConfigurationSave(&$element){
		if( isset($element->payment_params->security) && $element->payment_params->security && isset($element->payment_params->security_cvv) && $element->payment_params->security_cvv ) {
			$element->payment_params->ask_ccv = true;
		}
		if( empty($element->payment_params->currency) ) {
			$element->payment_params->currency = $this->getDefaultCurrency($element->payment_params->merchant_id, $element->payment_params->api_key, $element->payment_params->api_url);
		}
		return true;
	}
	
	protected function getDefaultCurrency($merchant_id, $api_key, $api_url){
		$currencies = $this->getAcceptedCurrencies($merchant_id, $api_key, $api_url);
		return;
	}
	
	protected function getAcceptedCurrencies($merchant_id, $api_key, $api_url){
		$params = array (
			'merchant_id' 	=> $merchant_id,
			'api_key' 		=> $api_key,
		);
		
		$response = $this->_sendRequest($api_url.'fetchCurrencyCodes.php', $params);
		
		if($response){
			$response_data = json_decode($response);
			if($response_data->response_code == 200) {
				return (array) $response_data->data;
			}
		}
		return array();
	}

/*** SwipeHQ additional functions ***/
        /**
         * Transaction verification
         * 
         * @param string $transaction_id
         * @return boolean
         */
        function _verifyTransaction($transaction_id, $merchant_id, $api_key, $api_url) {

            //parameters for transaction verification
            $data = array (
                'merchant_id'       => $merchant_id,
                'api_key'           => $api_key,
                'transaction_id'    => $transaction_id
            );

            $response = $this->_sendRequest($api_url.'verifyTransaction.php', $data);

            if (!empty($response)) {
                $response_data = json_decode($response);

                if ($response_data->response_code == 200 && $response_data->data->transaction_id == $transaction_id) {
                    return true;
                }
            }
            return false;
        }
        
        function _sendRequest($url, $data) {
             $ch = curl_init ($url);
             curl_setopt ($ch, CURLOPT_POST, 1);
             curl_setopt ($ch, CURLOPT_POSTFIELDS, $data);
             curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
             curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,0);
             curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,0);
             $response = curl_exec ($ch);
             curl_close ($ch);
             return $response;
        }
        
}